﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Globalization;

namespace Abacus
{
    public partial class Form1 : Form
    {
        private double x, y, z;

        public Form1()
        {
            InitializeComponent();
            TextX.Select();
            FunctionList.SelectedIndex = 0;
        }

        private void ButtonClose_Click(object sender, EventArgs e)
        {
            Close();
        }

        private double rad(double a)
        {
            if (RadioGRAD.Checked) return a / 180.0 * Math.PI;
            else return a;
        }

        private bool Parsing()
        {
            try
            {
                TextX.Text = TextX.Text.Replace(".", NumberFormatInfo.CurrentInfo.NumberDecimalSeparator);
                TextY.Text = TextY.Text.Replace(".", NumberFormatInfo.CurrentInfo.NumberDecimalSeparator);
                TextX.Text = TextX.Text.Replace(",", NumberFormatInfo.CurrentInfo.NumberDecimalSeparator);
                TextY.Text = TextY.Text.Replace(",", NumberFormatInfo.CurrentInfo.NumberDecimalSeparator);
                x = double.Parse(TextX.Text);
                y = double.Parse(TextY.Text);
            }
            catch
            {
                MessageBox.Show("Неверный формат поля X или Y.", "Calculator", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return false;
            }
            return true;
        }

        private void ButtonPlus_Click(object sender, EventArgs e)
        {
            if (Parsing())
            {
              switch( ((Button) sender).Text )
              {
                  case "+": z = x + y; break;
                  case "–": z = x - y; break;
                  case "X": z = x * y; break;
                  case "/": if (y != 0) z = x / y;
                      else MessageBox.Show("Деление на 0", "Calculator", MessageBoxButtons.OK, MessageBoxIcon.Error);
                      break;
                  case "f(x[,y])":
                      switch(FunctionList.Text)
                      {
                          case "sqrt":
                              if (x>=0) z=Math.Sqrt(x);
                              else MessageBox.Show("Корень из отрицательного числа", "Calculator", MessageBoxButtons.OK, MessageBoxIcon.Error);
                              break;
                          case "power":
                              if (x >= 0) z = Math.Pow(x, y);
                              else MessageBox.Show("Степень отрицательного числа не поддерживается", "Calculator", MessageBoxButtons.OK, MessageBoxIcon.Error);
                              break;
                          case "sin":
                              z = Math.Sin(rad(x));
                              break;
                          case "cos":
                              z = Math.Cos(rad(x));
                              break;

                      }
                      break;
              }
                TextZ.Text = z.ToString();
            }
        }

        private void zXToolStripMenuItem_Click(object sender, EventArgs e)
        {
            TextX.Text = TextZ.Text;
        }

        private void zYToolStripMenuItem_Click(object sender, EventArgs e)
        {
            TextY.Text = TextZ.Text;
        }
    }
}
